#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "config.h"
#include "packet.h"
#include "lists.h"
#include "value.h"
#include "tree.h"
#include "array.h"
#include "mapping.h"
#include "network.h"

value *
i3_p_startup_req_3 (void)
{
	value	*v = NULL;
	value	*m_services;
	value	*m_other;

#define MAP_NODE(kt, kd, dt, dd)		\
	mapping_data_new(					\
		value_new_data(kt, (void *)kd),	\
		value_new_data(dt, (void *)dd))

	m_services = mapping_create(NULL, "dd",
		// MAP_NODE(MM_STRING, "tell", MM_VALUE, 0),
		// MAP_NODE(MM_STRING, "emoteto", MM_VALUE, 0),
		// MAP_NODE(MM_STRING, "who", MM_VALUE, 0),
		// MAP_NODE(MM_STRING, "finger", MM_VALUE, 0),
		MAP_NODE(MM_STRING, "locate", MM_VALUE, 0),
		MAP_NODE(MM_STRING, "channel", MM_VALUE, 0)
		);
	m_other = mapping_new();

	v = packet_head_create ("startup-req-3", NULL, NULL, NULL);
	v = array_create(v, packet_fmt("startup-req-3"),
		0, -1, -1,
		CONFIG_PORT_USER, CONFIG_PORT_OOB, CONFIG_PORT_UDP,
		CONFIG_LIB_MINOR, CONFIG_LIB_MAJOR, CONFIG_DRIVER,
		CONFIG_MUDTYPE, CONFIG_STATUS, CONFIG_EMAIL,
		m_services, m_other);

	return v;
}

int
main (void)
{
	value	*v;
	FILE	*stream;
#define cfoo
#ifdef cfoo
	int		 sock;
	char	 buf[121];
#endif

	packet_init();

	v = i3_p_startup_req_3();

	// v = array_create(NULL, "v", 5);
	// tree_print(stderr, v);
	// fflush(stderr);

	network_set_connection(CONFIG_ROUTER_HOST, CONFIG_ROUTER_PORT);

#ifdef cfoo
	sock = network_make_connection();
	stream = fdopen(sock, "r+");
#else
	stream = fopen("/dev/null", "w");;
#endif

	tree_print(stderr, v);
	fflush(stderr);

	printf("Sending\n");
	tree_print(stream, v);
	printf("Sent\n");

	sleep(2);

	printf("Got %d\n", fread(&buf, sizeof(char), 120, stream));

#ifdef cfoo
	// fread(&buf, sizeof(char), 120, stream);
	printf("Reply %.120s\n", buf + 4);
#endif

	return 0;
}
